module Binst where

import List
import Debug.Trace

data Binst a =
	  Leaf 
	| Node (Binst a) a (Binst a)
	deriving (Eq, Show,Read)

search a Leaf = False
search a (Node tl b tr)
	| a == b = True
	| a < b = search a tl
	| a > b = search a tr

(?) a  = search a 

a +> Leaf = Node Leaf a Leaf
a +> t@(Node tl b tr) 
	| a == b = t
	| a < b = Node (a +> tl) b tr
	| otherwise = Node tl b (a +> tr)
 
binstMin Leaf = Nothing
binstMin (Node Leaf b _) = Just b
binstMin (Node tl _ _ ) = binstMin tl

dfs Leaf  = []
dfs (Node tl a tr) = (dfs tl)++a:(dfs tr)
 
delMin Leaf = Nothing
delMin (Node Leaf b tr) = Just (b,tr)
{-
next pattern could have been defined with 'case' construction as below
delMin (Node tl b tr) = case delMin tl of 
			  Nothing -> Just (b,tr)
			  Just (m,rtl) -> Just (m, Node rtl b tr)
-}

delMin (Node tl b tr) 
  | Just (m,rtl) <- delMin tl = Just (m, Node rtl b tr)
  | otherwise = Just (b, tr)

delMax Leaf = Nothing
delMax (Node tl b Leaf) = Just (b,tl)
delMax (Node tl b tr) 
  | Just (m,rtr) <- delMax tr = Just (m, Node tl b rtr)
  | otherwise = Just (b, tl)


udfs = unfoldr delMin

binstMax Leaf = Nothing
binstMax (Node _ b Leaf) = Just b
binstMax (Node _ _ tr) = binstMax tr



Leaf !- _ = Leaf
t@(Node Leaf b Leaf) !- a 
	| a==b = Leaf
	| otherwise = t
t@(Node Leaf b tr) !- a
	| a<b = t
	| a == b = tr 
		{-case delMin tr of
                    Just (m,rtr) -> Node Leaf m rtr
		    Nothing -> Leaf
		-}
	| a>b = Node Leaf b (t !- a) 
t@(Node tl b tr) !- a 
	| a<b = Node (tl !- a) b tr
	| a == b = case delMax tl of 
		    Just (m,rtl) -> Node rtl m tr
		    Nothing -> trace "Oh! Bad!" t 
        | a > b = Node tl  b (tr !- a)

ufldr p t 
 | Just (a,t1) <- p t = a:(ufldr p t1)
 | otherwise = []

ordered [] = True
ordered [a] = True
ordered (a:b:x) = (a<=b) && (ordered (b:x))

zordered xs = all (\ (a,b) -> a<=b) (zip xs (tail xs))

