(define leaf? null?)

(define (left t) (cadr t))

(define (right t) (caddr t))

(define (root t) (car t))

(define (exnode a) (list a (leaf) (leaf)))

(define (innode l a r) (list  a l r))

(define (leaf) '())

(define (search a t)
  (cond ((leaf? t) #f)
        ((= a (root t)) #t)
	((< a (root t)) (search a (left t)))
	(else (search a (right t)))))

(define (binstIns a t)
  (cond ((leaf? t) (exnode a))
        ((= a (root t)) t)
	((< a (root t)) (innode (binstIns a (left t)) (root t) (right t)))
	(else (innode (left t) (root t) (binstIns a (right t))))))

(define (set-left! t a) (set-car! (cdr t) a))
(define (set-right! t a) (set-car! (cddr t) a))

(define (incr t)
  (let loop ((tl t))
    (if (null? tl) t
      (begin (set-car! tl (+ (car tl) 10))
	     (loop (cdr tl))))))

(define (binstIns! a t)
  (let loop ((tl  t))
    (cond ((leaf? tl) (exnode a)) 
	  ((= a (root tl)) t) 
	  ((< a (root tl)) 
	   (if (leaf? (left tl)) 
	     (begin (set-left! tl (exnode a))
		    t) 
	     (loop (left tl))))
	  (else (if (leaf? (right tl)) 
		  (begin (set-right! tl  (exnode a))
			t) 
		  (loop (right tl)))))))



(define (dfs t)
  (cond ((leaf? t) (leaf))
	(else (append (dfs (left t)) (cons (root t) (dfs (right t)))))))

(define (Nothing) 'Nothing)
(define (isNothing? x) (eq? 'Nothing x))

(define (Just x)  (list x))
(define theJust  car)

(define pair cons)
(define fst car)
(define snd cdr)


(define (binstMin t)
  (cond ((leaf? t) (Nothing))
	((leaf? (left t)) (Just (root t)))
	(else (binstMin (right t)))))

(define (delMin t)
  (cond ((leaf? t) (Nothing))
	((leaf? (left t)) (Just (pair (root t) (right t))))
	(else (let ((auxt (theJust (delMin (left t)))))
		(Just (pair (fst auxt) 
			    (innode (snd auxt) (root t) (right t))))))))
(define (delMax t)
  (cond ((leaf? t) (Nothing))
	((leaf? (right t)) (Just (pair (root t) (left t))))
	(else (let ((auxt (theJust (delMax (right t)))))
		; crazy error abve: it was left : three hours to catch
		(Just (pair (fst auxt) 
			    (innode (left t) (root t) (snd auxt))))))))

(define (foldr op zero xs)
  (if (null? xs)
    zero
    (op (car xs) (foldr op zero (cdr xs)))))

(define (unfoldr p t)
  (let ((pt (p t)))
    (cond ((isNothing? pt) '())
	  (else (cons (fst (theJust pt)) (unfoldr p (snd (theJust pt))))))))

(define (binstDel t a)
  ;(print "del " a "in \n" t)
  (cond ((leaf? t) t)
	((and (leaf? (left t)) (leaf? (right t)))
	 (if (= a (root t)) (leaf)
	   t))
	((leaf? (left t)) ; (print "leafleft"); printing in despair
	 (cond ((< a (root t)) t)
	       ((= a (root t)) (right t))
	       ((> a (root t)) (innode (left t) 
				       (root t) 
				       (binstDel (right t) a)))))
	((< a (root t)) (innode (binstDel (left t) a) 
			 (root t) 
			 (right t)))
	((= a (root t)) ;(print "noleaf left a is root"); despair
	 (let* ((auxt (delMax (left t))) 
		(m (fst (theJust auxt))) 
		(rtl (snd (theJust auxt))))
	   ; (print "delMax" t "\n" auxt "\n" m " " rtl)
	   (innode rtl
		   m
		   (right t))))
	(else (innode (left t) (root t) (binstDel (right t) a)))))

	
	
(define (fromto l u) (if (= l u) (list l) (cons l (fromto (+ l 1) u))))

(define (fromdownto l u) 
  (if (= l u) (list l) (cons u (fromdownto l (- u 1)))))

(define (ordered? xs)
  (cond ((null? xs) #t)
	((null? (cdr xs)) #t)
	(else (and (<= (car xs) (cadr xs)) (ordered? (cdr xs))))))

  
