open OS;
open TextIO;
open List;
use "rbinst.sml";

val randgen:int = Real.round(Real.rem(Time.toReal (Time.now()),1013.0));

val nextrand: int ref = ref randgen;

 

fun random () = let val r = Random.randInt(Random.rand(1,!nextrand))
		in (nextrand := r; r) end; 

fun randintseq 0 xs = xs
 |  randintseq n xs = randintseq (n-1) ((random ())::xs)

fun intarg arg = let val (SOME n) = Int.fromString arg
                 in n end;



fun printSeq xs = app (fn i => print ((Int.toString i)^"\n")) xs;


fun main (cmd : string, args : string list) =
        let  val n = (intarg o nth)(args,0)
	     val xs = randintseq n []
             val p = nth(args,1)
             val t:(int RBinst) ref = ref RLeaf;
	     val ut = app (fn i=> insert (i,t)) xs
	     val d = nth(args,2)
 	     val dt = if d = "d"
		      then dfs t
		      else udfs t
        in ( printSeq dt;
             OS.Process.success)
        end;




