(*Open List*)

datatype 'a RBinst =
	  RLeaf 
	| RNode of 'a RBinst ref * 'a * 'a RBinst ref

fun search (a, ref RLeaf) = false
 |  search (a, ref (RNode (tl,b,tr))) = 
	if a = b then true
	else if a < b then  search (a, tl)
	else search (a, tr)

val rRLeaf:(int RBinst) ref = ref RLeaf
val nulltree: (int RBinst) ref = ref RLeaf
val exnode = fn a => RNode (rRLeaf,a,rRLeaf)


fun insert (a, t as (ref RLeaf)) = (t := (exnode a); ())  
 |  insert (a, t as (ref (RNode (tl, b, tr)))) = 
	if a = b then ()
	else if a < b andalso tl = rRLeaf
	then (t:= (RNode (ref (exnode a),b,tr)); ())
	else if a<b 
        then insert (a, tl)
	else if a>b andalso tr = rRLeaf
	then (t:= (RNode (tl, b, ref (exnode a))); ())
	else insert (a, tr)
 
(*
fun binstMin RLeaf = NONE
 |  binstMin (RNode (RLeaf, b, _)) = SOME b
 |  binstMin (RNode (tl, _, _ )) = binstMin tl
*)

fun dfs (ref RLeaf)  = []
 |  dfs (ref (RNode (tl, a, tr))) = (dfs tl)@a::(dfs tr)
 
fun delMin (ref RLeaf) = NONE
 |  delMin (ref (RNode (ref RLeaf, b, tr))) = SOME (b,tr)
 |  delMin (ref (RNode (tl, b, tr))) = 
	case delMin tl  
	of NONE => SOME (b,tr)
 	| SOME (m,rtl) => SOME (m, ref (RNode (rtl, b, tr)))


fun delMax (ref RLeaf) = NONE
 |  delMax (ref (RNode (tl, b, ref RLeaf))) = SOME (b,tl)
 |  delMax (ref (RNode (tl, b, tr))) = 
	case delMax tl
	of NONE => SOME (b,tl)
	|  SOME (m,rtr) => SOME (m, ref (RNode (tl,b,rtr)))
 
fun unfoldr p t = case p t
        	  of NONE => []
		  |  SOME (a, tr) => a::(unfoldr p tr)

fun udfs t = unfoldr delMin t


(*
binstMax RLeaf = NONE
binstMax (RNode _ b RLeaf) = SOME b
binstMax (RNode _ _ tr) = binstMax tr



RLeaf !- _ = RLeaf
t@(RNode RLeaf b RLeaf) !- a 
	| a==b = RLeaf
	| otherwise = t
  
{-t@(RNode RLeaf b tr) !- a
	| a<b = t
	| a == b = case delMin tr of
                    SOME (m,rtr) -> RNode RLeaf m rtr
		    NONE -> RLeaf
	| a>b = RNode RLeaf b (t !- a) -}
t@(RNode tl b tr) !- a 
	| a<b = RNode (tl !- a) b tr
	| a == b = case delMax tl of 
		    SOME (m,rtl) -> RNode rtl m tr
		    NONE -> t -- if it ever gets here, ghc is the problem
        | a > b = RNode tl  b (tr !- a)

ufldr p t 
 | SOME (a,t1) <- p t = a:(ufldr p t1)
 | otherwise = []
*)
